// SaleTest.cpp
#include "../TestHarness/TestHarness.h"
#include "Sale.h"
#include "GetPrice.h"

int main()
{
	TestResult tr;
	TestRegistry::runAllTests( tr );
	return 0;
}

static char* milkBarcode = "a123";
static int milkPrice = 199;
static char* cookieBarcode = "b234";
static int cookiePrice = 50;

int GetPrice( char* barCode )
{
   if ( 0 == strcmp( barCode, milkBarcode ) )
      return milkPrice;
   else if ( 0 == strcmp( barCode, cookieBarcode ) )
      return cookiePrice;
}

TEST( Sale, totalNewSale )
{
	Initialize( );
	CHECK( 0 == GetTotal( ) );
}

TEST( Sale, sellOneItem )
{
	Initialize( );
	BuyItem( milkBarcode );
	CHECK( milkPrice == GetTotal( ) );
}

TEST( Sale, sellTwoItems )
{
	Initialize( );
	CHECK( 0 == GetTotal( ) );
	BuyItem( milkBarcode );
	BuyItem( milkBarcode );
	CHECK( 2 * milkPrice == GetTotal( ) );
}

TEST( Sale, sellTwoProducts )
{
	Initialize( );
	BuyItem( milkBarcode );
	BuyItem( cookieBarcode );
	CHECK( milkPrice + cookiePrice == GetTotal( ) );
}
// Sale.h
#ifdef __cplusplus
extern "C"
{
#endif

int GetTotal( );
void BuyItem( char* barCode );
void Initialize( );

#ifdef __cplusplus
}
#endif
// Sale.c
#include "Sale.h"

static int total = 0;

void Initialize( )
{
	total = 0;
}

int GetTotal()
{
	return total;
}

void BuyItem( char* barCode )
{
	int price = GetPrice( barCode );
	total += price;
}
// GetPrice.h
#ifdef __cplusplus
extern "C"
{
#endif

int GetPrice( char* barcode );

#ifdef __cplusplus
}
#endif
// GetPrice.c
#include "GetPrice.h"

int GetPrice( char* barcode )
{
	/*  do SQL retrieval here */
}


